<template>
  <span>
  <v-btn @click="openRelatorio" outline color="#1D334B">Relatorio 
      <v-icon  right dark>assessment</v-icon>
  </v-btn>

   <v-btn @click="openForm" outline color="#1D334B">Cadastrar
      <v-icon  right dark>add_circle_outline</v-icon>
  </v-btn>
  <v-layout justify-center>   
    <v-dialog v-model="visible" fullscreen hide-overlay transition="dialog-bottom-transition">
      
        <v-toolbar dark color="#1D334B">
          <v-btn icon dark @click="closeForm">
            <v-icon>close</v-icon>
          </v-btn>
          <v-toolbar-title>{{title}}</v-toolbar-title>
          <v-spacer></v-spacer>
          <v-toolbar-items>
            <v-btn color="#1D334B" :disabled="!valid" text @click="saveAndCloseForm">Save</v-btn>
          </v-toolbar-items>
        </v-toolbar>        

          <v-card>
            <input type="text" :value="getUser" hidden >
           <v-form
                  ref="form"
                  v-model="valid"
                  :lazy-validation="lazy"
                >
            <v-container grid-list-md text-center>
              <v-layout align-center justify-space-around row fill-height wrap>
               
                  <v-flex xs12>
                       <v-text-field
                        v-model="userForm.name"
                        :counter="60"
                        :rules="nameRules"
                        label="Nome Completo"
                        required
                      ></v-text-field>
                  </v-flex>

                  <v-flex xs6>
                     <v-text-field
                      v-model="userForm.login"
                      label="Login"
                       :rules="loginRules"
                      :counter="12"
                      required
                    ></v-text-field>
                  </v-flex>

                  <v-flex xs6>
                      <v-text-field
                      v-model="userForm.email"
                      :rules="emailRules"
                      label="E-mail"
                      required
                    ></v-text-field>
                  </v-flex>

                   <v-flex xs6>
                      <v-text-field
                      v-model="userForm.password"
                      label="Senha"
                      type="password"
                      v-if="!edit"
                      required
                    ></v-text-field>
                  </v-flex>

                   <v-flex xs6>
                      <v-text-field
                      v-model="passwordConfirm"
                      label="Repita a Senha"
                      :rules="passwordConfirmRules"
                      type="password"
                      v-if="!edit"
                      required
                    ></v-text-field>
                  </v-flex>
                 
                  <v-flex xs6>
                    <v-select
                      v-model="userForm.tempo_expiracao_senha"
                      :items="rangeDay"
                      :rules="[v => !!v || 'Este Campo é obrigatorio']"
                      label="Tempo de Expiraçāo da Senha"
                      required
                    ></v-select>
                  </v-flex>

                  <v-flex xs6>
                    <v-select
                      v-model="userForm.cod_autorizacao"
                      :items="rangeCode"
                      :rules="[v => !!v || 'Este Campo é obrigatorio']"
                      label="Codigo de Autorizaçāo"
                      required
                    ></v-select>
                  </v-flex>

                   <v-flex xs6>
                    <v-text-field
                    v-model="userForm.cod_pessoa"
                    label="Código Pessoa"
                    :counter="10"
                    type="number"
                    required
                  ></v-text-field>
                  </v-flex>
             
                  <v-flex  xs6 >
                  <v-checkbox
                    v-model="userForm.status_usuario"
                    label="Usuário Ativo ?"
                    required
                  ></v-checkbox>
                  </v-flex>

                  <v-flex xs6>
                    <v-select
                      v-model="userForm.profiles"
                      :items="perfis"
                      :rules="[v => !!v || 'Este Campo é obrigatorio']"
                      label="Selecione um ou mais perfis para o usuário"
                      required
                       item-text="name_profile"
                       item-value="id"
                       :multiple="true"
                    ></v-select>
                  </v-flex>

                   <v-flex xs6>
                    <v-select
                      v-model="userForm.gadgets"
                      :items="gadgets"
                      :rules="[v => !!v || 'Este Campo é obrigatorio']"
                      :multiple="true"
                      label="Adicione os dispositivos do usuário"
                      required
                       item-text="gadget_description"
                       item-value="id"
                    ></v-select>
                  </v-flex>
               
              </v-layout>
            </v-container>
           </v-form>
      </v-card>
    </v-dialog>
  </v-layout>
  </span>
</template>


<script>

  import { mapState } from 'vuex'
  export default {
    data () {
      return {
       perfis: [],
       gadgets: [], 
       passwordConfirm: null,
       userId: null,
       edit: false,
       userForm:{
         name: null,
         login: null,
         email: null,
         password: null,
         tempo_expiracao_senha: null,
         cod_autorizacao: null,
         cod_pessoa: null,
         status_usuario: false,
         profiles:[],
         gadgets:[]
       },
       valid: true,
        nameRules: [
          v => !!v || 'Nome é obrigatório',
          v => (v && v.length <= 60) || 'Nome deve conter menos de 60 caracteres',
        ],
         loginRules: [
          v => !!v || 'Login é obrigatório',
        ],
        passwordConfirmRules:[
          v => (v == this.userForm.password) || 'A senhas devem ser iguais' 
        ],
        emailRules: [
          v => !!v || 'E-mail é obrigatório',
          v => /.+@.+\..+/.test(v) || 'E-mail deve ser Válido',
        ],
        select: null,
        rangeDay: [
          20,
          40,
          60,
          70,
        ],
        rangeCode:[
          'A',
          'B',
          'C',
        ],
        checkbox: false,
        lazy: false,
      }
    },
    mounted(){
       this.loadProfiles();
       this.loadGadgets();
    },
    methods: {
      openForm: function()
      {
        this.reset();
        this.$store.dispatch('userForm/setVisible', true);
        this.$store.dispatch('userForm/setTitle', 'Cadastro de Usuário');
      },
      openRelatorio: function(){
        this.axios({
                method: 'GET',
                url: 'http://pmz.local/api/relatorio',
                responseType: 'blob'
                    }).then(response => {
                      console.log(response.data.type);
                        if (response.data.type == 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' || response.data.type == 'application/pdf') {
                            const url = window.URL.createObjectURL(new Blob([response.data]));
                            const link = document.createElement('a');
                            link.href = url;
                            link.setAttribute('download', `relatorio.pdf`);
                            document.body.appendChild(link);
                            link.click();
                        } 
                    }).catch(error => {
                      console.log(error);
                    })
      },
      closeForm: function()
      {
         this.$store.dispatch('userForm/setVisible', false);
      },
      saveAndCloseForm: async function()
      {
        if(!this.edit){
          let response = await this.$store.dispatch('user/addUsers', this.userForm);
          this.$store.dispatch('userForm/setVisible', false);
        }else{
          let response = await this.$store.dispatch('user/updateUser', {user: this.userForm, id: this.userId });
          this.$store.dispatch('userForm/setVisible', false);
        }
        
     },
      validate () {
        if (this.$refs.form.validate()) {
          this.snackbar = true
        }
      },
      reset () {
        this.$refs.form.reset()
        this.userId = null;
        this.edit = false;
      },
      resetValidation () {
        this.$refs.form.resetValidation()
      },
      loadProfiles(){
         this.axios.get(`${process.env.VUE_APP_ROOT_API}profiles`).then(response =>{
          let data = response.data;
          this.perfis.push(...data);
        })
      },
      loadGadgets(){
        this.axios.get(`${process.env.VUE_APP_ROOT_API}gadgets`).then(response =>{
          let data = response.data;
          this.gadgets.push(...data);
        })
      }

    },
    computed: {
            ...mapState('userForm', [
                'visible',
                'title'
            ]),

            getUser(){
              let user = this.$store.state.userForm.selectedUser
              if(user != null){
                this.edit = true;
                this.userId = user.id;
                this.userForm.name = user.name;
                this.userForm.login = user.login;
                this.userForm.password = user.password;
                this.userForm.email = user.email;
                this.passwordConfirm = user.password;
                this.userForm.tempo_expiracao_senha = user.tempo_expiracao_senha;
                this.userForm.cod_autorizacao = user.cod_autorizacao;
                this.userForm.status_usuario = user.status_usuario == 'a' ? true : false;
                this.userForm.cod_pessoa = user.cod_pessoa;
                return user.id
              }
            }
        }
  }
</script>